﻿/*
 * usart0.c
 *
 * Created: 2021-10-07 오전 10:49:49
 *  Author: WIN
 */ 

#define	F_CPU	16000000UL

#include <avr/io.h>
#include <stdio.h>

int uart0_putchar(char ch, FILE *stream);
int uart0_getchar(FILE *stream);

FILE uart0_dev = FDEV_SETUP_STREAM(uart0_putchar, uart0_getchar, _FDEV_SETUP_RW);

void uart0_init(uint32_t baudrate)
{
	UCSR0A = 0b00000000;	// U2X0=0: No double speed
	UCSR0B = 0b00011000;	// Enable Rx and Tx
	UCSR0C = 0b00000110;	// Async mode, No Parity,
							// 1 Stop bit, 8 Data bits
	UBRR0  = F_CPU/(baudrate*16UL)-1;	// Baud Rate
	
	stdout = &uart0_dev;
	stdin = &uart0_dev;
}

int uart0_putchar(char ch, FILE *stream)
{
	while (!(UCSR0A & (1 << UDRE0)));	// Wait for empty transmit buffer
	UDR0 = ch;
	return 0;							// sends the data
}

int uart0_getchar(FILE *stream)
{
	// Wait until data is received (RXC0 bit)
	while ((UCSR0A & (1 << 7)) == 0);
	
	return UDR0;	// Read received data
}
